unit Unit1;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;
 FUNCTION DoPack50(InPack : STRING) : String;
 FUNCTION DoUnPack50(InUnPack : STRING) : String;
 type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button3: TButton;
    List1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
var
  Form1: TForm1;
implementation
{$R *.DFM}
CONST
PackChars : STRING[50] = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ!@#-$%_()&{}';

procedure TForm1.Button1Click(Sender: TObject);
Var
 Edit1Txt : String    ;
begin
 Edit1Txt := Edit1.Text            ;
 Edit2.Text :=(DoPack50(Edit1Txt)) ;
end;

procedure TForm1.Button2Click(Sender: TObject);
Var
 Edit2Txt : String       ;
begin
 Edit2Txt := Edit2.Text  ;
 Edit1.Text :=(DoUnPack50(Edit2Txt));
end;
procedure TForm1.Button3Click(Sender: TObject);
begin
 Edit1.Text :=''  ;
 Edit2.Text :=''  ;
 end;
FUNCTION REALDiv(A, B: REAL) : REAL;
BEGIN
     REALDiv := INT(A/B);
END;

FUNCTION ToREAL(InString : STRING) : REAL;
VAR
OK : BOOLEAN;
Count : INTEGER;
TmpResult : REAL;
BEGIN
     OK := TRUE;
     Count := 1;    
     TmpResult := 0.0;
     While (Count <=Length(Instring)) AND OK DO
     BEGIN
          IF InString[Count] in ['0'..'9'] THEN
          BEGIN
           TmpResult := TmpResult * 10 + (ORD(InString[Count])-$30);
          END
          ELSE
          BEGIN
               OK := FALSE;
          END;
               INC(Count);
     END;
     IF OK THEN
     BEGIN
          ToREAL := TmpResult;
     END
     ELSE
     BEGIN
          ToREAL := 0.0;
     END;
END;

FUNCTION PackNBr(Nbr : REAL ; Cifre : INTEGER) : STRING;
VAR
Rest, Count : INTEGER;
TmpResult   : STRING;

FUNCTION GetRest(A, B : REAL) : INTEGER;
VAR
C : REAL;
BEGIN
     C := REALDiv(A,B);
     GetRest := Round(A-C*B);
END;

BEGIN
     TmpResult := '';
     FOR Count := 1 TO CIFRE DO
     BEGIN
          Rest := GetRest(Nbr, 50);
          Nbr := REALDiv(Nbr,50);
          TmpResult := PackChars[Rest+1] + TmpResult;
     END;
          PackNBr := TmpResult;
END;

FUNCTION UnPackNbr(InString : STRING) : REAL;
VAR
Count     : INTEGER;
P         : LONGINT;
OK        : BOOLEAN;
TmpResult : REAL;
BEGIN
 TmpResult := 0.0;
        OK := TRUE;
     Count := 1;      
 WHILE (Count <= Length(InString)) AND OK DO
  BEGIN
          P := Pos(InString[Count], PackChars)-1;
       IF P >= 0 THEN BEGIN
            TmpResult :=(TmpResult*50)+P;
       END
       ELSE
       BEGIN
         OK := FALSE;
       END;
         INC(Count);
  END;
     IF OK THEN
       UnPackNbr := TmpResult
     ELSE
       UnPackNBr := -1;
END;

FUNCTION DoPack50(InPack : STRING) : String;
BEGIN
   DoPack50 := PackNbr(ToREAL(InPAck),8);
END;

FUNCTION DoUnPack50(InUnPack : STRING) : String;
VAR
TmpResult : STRING;
BEGIN
     TmpResult := '';
     STR(UnPackNbr(InUnPack):1:0,TmpResult);
     DoUnpack50 := TmpResult;
END;
BEGIN

END.
